
 var com="V";
 window.addEventListener("load",onloadfuncs); 
 function onloadfuncs()
 {  
    req("V","TIME_SERIES_DAILY","chartContainer");
    let l=0;
    if(localStorage.getItem("favourites"))
    {
        let y=JSON.parse(localStorage['favourites']);
        l=y.length;
        if (y.indexOf(com) != -1)
        { document.getElementById("fav").innerHTML="Remove From Favourites";} 
        else{
        { document.getElementById("fav").innerHTML="Add To Favourites";} 

        }

    }
    document.getElementById("countfav").innerHTML="("+ l +")"; 

 }

function req(company,selection,divid)
 { 
    
    
    let xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange =function() {
      if (this.readyState == 4 && this.status == 200) 
      { 
          console.log(company);
        extract_info(this,company,divid); 
      }
    };
    let urx="https://www.alphavantage.co/query?function=" +selection +"&symbol=" + company + "&apikey=KZOUJSNAGWMIXBWB";
    xhttp.open("GET",urx, true);
    xhttp.send();
}
function datapoints(inf,dates)
{
    let ar=[];
    for(let i=0;i<100;i++)
    {
        let z={x:new Date(dates[i]),y:Number(inf[i][3])};
        ar.push(z);

    }
    return ar;
}  
function fill(x)
{
           document.getElementById("company").value=x.innerHTML;
           document.getElementById("sug1").style.display="none";
           document.getElementById("sug2").style.display="none";
}
function extract_info(x2,company,divid)
{     
    let res=x2.responseText;
    let y=JSON.parse(res);
    let ar= Object.values(y);
    let obj= ar[1];
    let  inf=[];
    let dates=Object.keys(obj);
    document.getElementById("nyse").innerHTML="NYSE:"+company;
    
    let headers=Object.keys(obj[dates[0]]);
    for(let i=0;i<100;i++)
    {
         inf.push(Object.values(obj[dates[i]]));
    }
   
    let diff=inf[0][3]-inf[1][3];
    diff=diff.toFixed(2);
    let diffpercent=Math.abs(diff)*100/inf[0][3];
    diffpercent=diffpercent.toFixed(2);
    let cur=Number(inf[0][3]).toFixed(2);
    
    document.getElementById("closeprice").innerHTML=cur;
    document.getElementById("differ").innerHTML=diff;
    document.getElementById("percent").innerHTML="("+diffpercent+"%)";
    if(diff<0)
    {
      document.getElementById("symbol").innerHTML="&darr;";
     let x= document.getElementsByClassName("zone");
     x[0].style.color="red";x[1].style.color="red";x[2].style.color="red";
     
    }

     
    let chart = new CanvasJS.Chart(divid, {
      animationEnabled: true,
      title:{
        text: "Stock Price of "+ company
      },
      
      axisX:{
        valueFormatString: "DD MMM YYYY",
        crosshair: {
          enabled: true,
          snapToDataPoint:true
        }
      },
      axisY: {
        title: "Closing Price (in USD)",
        valueFormatString: "$##0.00",
        crosshair: {
          enabled: true,
          snapToDataPoint: true,
          labelFormatter: function(e) {
            return "$" + CanvasJS.formatNumber(e.value, "##0.00");
          }
        }
      },
      
      data: [{
        type: "area",
        xValueFormatString: "DD MMM YYYY",
        yValueFormatString: "$##0.00",
        dataPoints:datapoints(inf,dates)
        
        
      }]
    });
    chart.render();
  }
  
function searchcap()
{
    document.getElementById("list").style.display="inline";
   let p=document.getElementById("company");
   p.value=p.value.toUpperCase();
  let searchn=p.value;
  let xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
      if (this.readyState == 4 && this.status == 200) 
      {
        let res=xhttp.responseText;
        let obj=JSON.parse(res);
        let arr2=obj.bestMatches;
        let y1=Object.values(arr2[0]);
        let y2=Object.values(arr2[1]);
        document.getElementById("sug1").style.display="block";
        document.getElementById("sug2").style.display="block";  
        document.getElementById("sug1").innerHTML=y1[0]+":"+y1[1];
        document.getElementById("sug2").innerHTML=y2[0]+":"+y2[1];
        
       

      }
    };
    let urx="https://www.alphavantage.co/query?function=SYMBOL_SEARCH&keywords="+searchn+"&apikey=KZOUJSNAGWMIXBWB";
   
    xhttp.open("GET",urx, true);
    xhttp.send();
}
function checkfav(com)
{
  let x=localStorage.getItem("favourites");
  let y="Add To Favourites";
  if(x)
  {
     var storagearr = JSON.parse(localStorage['favourites']);
     if (storagearr.indexOf(com) == -1)
      { 
         document.getElementById("fav").innerHTML=y;
      }
     else 
      {
        document.getElementById("fav").innerHTML="Remove From Favourites";
      }
  }
  else{
    document.getElementById("fav").innerHTML=y;
  }

}

function getdatas()
{
  
    var company=document.getElementById("company").value;
    var selection=document.getElementById("filter").value;
    let i;
    let n=company.length;
    for(i=0;i<n;i++)
    {
        if(company[i]==':')
        break;
    }
    company=company.substring(0,i);
    com=company;
    checkfav(com);


    req(company,selection,"chartContainer"); 
}

function addtofav(favbut)
{   
    if(favbut.innerHTML=="Add To Favourites")
    {
    
    let x=localStorage.getItem("favourites");
    if(x)
    {
       var storagearr = JSON.parse(localStorage['favourites']);
       if (storagearr.indexOf(com) == -1)
        { 
        storagearr.push(com);
        localStorage.setItem('favourites', JSON.stringify(storagearr));
        document.getElementById("countfav").innerHTML="("+ storagearr.length +")";
        }
       else 
        {
          
          console.log('item already in favorites');
        }
    }
    else
    {

        var arr= [];
        arr.push(com);
        localStorage.setItem("favourites", JSON.stringify(arr));
        console.log('New favourites list');
        document.getElementById("countfav").innerHTML="(1)";

    }
    favbut.innerHTML="Remove From Favourites";
    console.log("fav added succesfully")
}
/* remove fav */
else{
    var storagearr = JSON.parse(localStorage['favourites']);
    var filteredary = storagearr.filter(function(ele) { return ele != com });
    localStorage.setItem("favourites",JSON.stringify(filteredary));
    document.getElementById("countfav").innerHTML="(" +filteredary.length + ")";

    favbut.innerHTML="Add To Favourites";
    console.log("fav removed succesfully");
    }

}




    




    
 
  
